Cyclotomic(106743) fails
Status: Closed Start date: 18 Oct 2012

Priority: High Due date:  

Assignee: John Abbott % Done: 100%

Category: Incomplete function Estimated time: 0.00 hour

Target version: CoCoA-5.0.3 Spent time: 1.00 hour

Description

How is this possible?

# Cyclotomic(106743,x);

ERROR: Inexact division (i.e. quotient does not exist in ring or monoid)

 

I only wanted to verify some results in my BigFactor paper then CoCoA-5 does this to me? :-(

[moral of the story: don't verify your results prior to publishing :-]

Related issues:

Related to CoCoALib - Design #268: Exponent range (in power products) Closed 18 Oct 2012

Related to CoCoALib - Slug #679: power for PPs is too slow Closed 13 Apr 2015

History

#1 - 18 Oct 2012 12:52 - John Abbott

- Status changed from New to Resolved

- Assignee set to John Abbott

The problem was silent exponent overflow.  In the file config.H there is the line:

  typedef unsigned short SmallExponent_t;

 

Anna found the clue when gcd(x^106743-1,x^4641-1) gave x-1 which is impossible because 106743=23*4641.  It was an easy step to guess that

exponent overflow had occurred.

So what should the definition in config.H be?  The one which uses less space, is fine for almost all computation, and is probably a bit faster (i.e.

unsigned short); or one which allows "ridiculously large" computations (i.e. unsigned int, or should we even go all the way to unsigned long or

unsigned long long for users of C++11?).  How ridiculous should we allow the user to be? :-)

#2 - 18 Oct 2012 13:50 - John Abbott

- Status changed from Resolved to Closed
- % Done changed from 0 to 100

Closing this issue because the problem is that addressed in issue #268 (namely the range of exponents to allow).

#3 - 21 May 2013 18:03 - Anna Maria Bigatti

- Category set to Incomplete function

- Target version set to CoCoA-5.0.3
